import { Declaration } from 'typescript';
import { MethodMemberDoc } from './MethodMemberDoc';
import { PropertyMemberDoc } from './PropertyMemberDoc';
/**
 * This represents a getter or setter overload of an accessor property.
 * There will be a PropertyMemberDoc that contains these docs.
 */
export declare class AccessorInfoDoc extends MethodMemberDoc {
    accessorType: 'get' | 'set';
    propertyDoc: PropertyMemberDoc;
    docType: string;
    name: string;
    id: string;
    aliases: string[];
    anchor: string;
    constructor(accessorType: 'get' | 'set', propertyDoc: PropertyMemberDoc, declaration: Declaration);
}
