"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FileInfo_1 = require("../services/TsParser/FileInfo");
var getContent_1 = require("../services/TsParser/getContent");
var BaseApiDoc = /** @class */ (function () {
    function BaseApiDoc(moduleDoc, symbol, declaration, aliasSymbol) {
        this.moduleDoc = moduleDoc;
        this.symbol = symbol;
        this.declaration = declaration;
        this.aliasSymbol = aliasSymbol;
        this.name = this.aliasSymbol ? this.aliasSymbol.name : this.symbol.name;
        this.aliases = [this.name, this.moduleDoc.id + "/" + this.name];
        this.id = this.moduleDoc.id + "/" + this.name;
        this.basePath = this.moduleDoc.basePath;
        this.fileInfo = new FileInfo_1.FileInfo(this.declaration, this.basePath);
        this.startingLine = this.fileInfo.location.start.line +
            (this.fileInfo.location.start.character ? 1 : 0);
        this.endingLine = this.fileInfo.location.end.line;
        this.content = getContent_1.getContent(this.declaration);
        this.path = '';
        this.outputPath = '';
        this.originalModule = this.fileInfo.projectRelativePath
            .replace(new RegExp("\." + this.fileInfo.extension + "$"), "");
        this.typeChecker = this.moduleDoc.typeChecker;
    }
    return BaseApiDoc;
}());
exports.BaseApiDoc = BaseApiDoc;
//# sourceMappingURL=ApiDoc.js.map