import { Declaration, Symbol, TypeChecker } from 'typescript';
import { FileInfo } from '../services/TsParser/FileInfo';
import { ParsedDecorator } from "../services/TsParser/getDecorators";
import { ApiDoc } from './ApiDoc';
import { ContainerExportDoc } from './ContainerExportDoc';
import { ModuleDoc } from './ModuleDoc';
/**
 * This document represents a member of a ClassLikeExportDoc.
 */
export declare abstract class MemberDoc implements ApiDoc {
    containerDoc: ContainerExportDoc;
    symbol: Symbol;
    declaration: Declaration;
    docType: string;
    abstract name: string;
    abstract id: string;
    abstract aliases: string[];
    abstract anchor: string;
    path: string;
    outputPath: string;
    content: string;
    basePath: string;
    fileInfo: FileInfo;
    startingLine: number;
    endingLine: number;
    typeChecker: TypeChecker;
    moduleDoc: ModuleDoc;
    accessibility: string;
    decorators: ParsedDecorator[] | undefined;
    type: string;
    isOptional: boolean;
    isGetAccessor: boolean;
    isSetAccessor: boolean;
    isCallMember: boolean;
    isNewMember: boolean;
    isReadonly: boolean;
    isAbstract: boolean;
    isStatic: boolean;
    constructor(containerDoc: ContainerExportDoc, symbol: Symbol, declaration: Declaration);
}
