import { Declaration, TypeChecker } from 'typescript';
import { ContainerExportDoc } from './ContainerExportDoc';
import { ModuleDoc } from './ModuleDoc';
import { ParameterDoc } from './ParameterDoc';
export interface ParamTag {
    name: string;
    description: string;
}
/**
 * Docs that represent exported functions or methods.
 */
export interface ParameterContainer {
    name: string;
    id: string;
    aliases: string[];
    parameterDocs: ParameterDoc[];
    parameters: string[];
    type: string;
    containerDoc: ModuleDoc | ContainerExportDoc;
    moduleDoc: ModuleDoc;
    declaration: Declaration;
    basePath: string;
    typeChecker: TypeChecker;
    params?: ParamTag[];
}
export declare function getParameters(callableDoc: ParameterContainer): ParameterDoc[];
