"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var nodeToString_1 = require("../services/TsParser/nodeToString");
var ParameterDoc_1 = require("./ParameterDoc");
function getParameters(callableDoc) {
    var declaration = callableDoc.declaration;
    var signature = callableDoc.typeChecker.getSignatureFromDeclaration(declaration);
    if (!signature) {
        var name = declaration.name ? nodeToString_1.nodeToString(declaration.name) : 'unknown';
        throw new Error("Invalid call signature for \"" + name + "\" in " + declaration.getSourceFile().fileName + " at line " + declaration.getStart());
    }
    return signature.getParameters().map(function (parameter) {
        return new ParameterDoc_1.ParameterDoc(callableDoc, parameter, parameter.valueDeclaration);
    });
}
exports.getParameters = getParameters;
//# sourceMappingURL=ParameterContainer.js.map