import { ParameterDeclaration, Symbol } from 'typescript';
import { BaseApiDoc } from './ApiDoc';
import { ParameterContainer } from './ParameterContainer';
/**
 * This represents a call parameter of an exported function or of a method of a class or interface.
 * You can find them on the `FunctionExportDoc.parameters` or `MethodMemberDoc.parameters` properties.
 * They are generated by the call to `getParameters` service.
 */
export declare class ParameterDoc extends BaseApiDoc {
    container: ParameterContainer;
    symbol: Symbol;
    declaration: ParameterDeclaration;
    docType: string;
    type: string;
    isOptional: boolean;
    isRestParam: boolean;
    defaultValue: string | undefined;
    paramText: string;
    description: string;
    constructor(container: ParameterContainer, symbol: Symbol, declaration: ParameterDeclaration);
    getParamText(): string;
}
