"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dgeni_1 = require("dgeni");
var mockPackage = require('../mocks/mockPackage');
var path = require('canonical-path');
describe('mergeParameterInfo', function () {
    var dgeni;
    var injector;
    var tsProcessor;
    var mergeParameterInfoProcessor;
    var parseTagsProcessor;
    var extractTagsProcessor;
    beforeEach(function () {
        dgeni = new dgeni_1.Dgeni([mockPackage()]);
        injector = dgeni.configureInjector();
        tsProcessor = injector.get('readTypeScriptModules');
        parseTagsProcessor = injector.get('parseTagsProcessor');
        extractTagsProcessor = injector.get('extractTagsProcessor');
        mergeParameterInfoProcessor = injector.get('mergeParameterInfo');
        tsProcessor.basePath = path.resolve(__dirname, '../mocks/readTypeScriptModules');
        tsProcessor.sourceFiles = ['methodParameters.ts'];
    });
    it('should merge the param tags into the parameter docs', function () {
        var docsArray = [];
        tsProcessor.$process(docsArray);
        parseTagsProcessor.$process(docsArray);
        extractTagsProcessor.$process(docsArray);
        mergeParameterInfoProcessor.$process(docsArray);
        var param3 = docsArray.find(function (doc) { return doc.name === 'param3' && doc.container.name === 'method2'; });
        expect(param3.id).toEqual('methodParameters/TestClass.method2()~param3');
        expect(param3.description).toEqual('description of param3');
        expect(param3.type).toEqual('string');
        var param4 = docsArray.find(function (doc) { return doc.name === 'param4' && doc.container.name === 'method2'; });
        expect(param4.id).toEqual('methodParameters/TestClass.method2()~param4');
        expect(param4.description).toEqual('description of param4');
        expect(param4.type).toEqual('number');
    });
});
//# sourceMappingURL=mergeParameterInfo.spec.js.map