"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var glob_1 = require("glob");
var lodash_1 = require("lodash");
function expandSourceFiles(sourceFiles, basePath) {
    var filePaths = [];
    sourceFiles.forEach(function (sourcePattern) {
        if (isSourcePattern(sourcePattern)) {
            var include = glob_1.sync(sourcePattern.include, { cwd: basePath });
            var exclude = sourcePattern.exclude ? glob_1.sync(sourcePattern.exclude, { cwd: basePath }) : [];
            filePaths = filePaths.concat(lodash_1.difference(include, exclude));
        }
        else {
            filePaths = filePaths.concat(glob_1.sync(sourcePattern, { cwd: basePath }));
        }
    });
    return filePaths;
}
exports.expandSourceFiles = expandSourceFiles;
function isSourcePattern(pattern) {
    return !!pattern.include;
}
//# sourceMappingURL=SourcePattern.js.map