"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var getAccessibility_1 = require("./getAccessibility");
var path = require('canonical-path');
describe('getAccessibility', function () {
    var parser;
    var basePath;
    beforeEach(function () {
        parser = new _1.TsParser(require('dgeni/lib/mocks/log')(false));
        basePath = path.resolve(__dirname, '../../mocks');
    });
    it('should return the accessibility of class members', function () {
        var parseInfo = parser.parse(['tsParser/getAccessibility.test.ts'], basePath);
        var module = parseInfo.moduleSymbols[0];
        var testClassMembers = module.exportArray[0].members;
        var xee = testClassMembers.get('xee');
        expect(getAccessibility_1.getAccessibility(xee.declarations[0])).toEqual('public');
        var yuu = testClassMembers.get('yuu');
        expect(getAccessibility_1.getAccessibility(yuu.declarations[0])).toEqual('public');
        var bar = testClassMembers.get('bar');
        expect(getAccessibility_1.getAccessibility(bar.declarations[0])).toEqual('protected');
        var foo = testClassMembers.get('foo');
        expect(getAccessibility_1.getAccessibility(foo.declarations[0])).toEqual('private');
    });
});
//# sourceMappingURL=getAccessibility.spec.js.map