"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var typescript_1 = require("typescript");
var getTypeText_1 = require("./getTypeText");
var nodeToString_1 = require("./nodeToString");
function getDeclarationTypeText(declaration) {
    // if the declaration has an explicit type then use that
    var type = getType(declaration);
    if (type)
        return getTypeText_1.getTypeText(type);
    // if the declaration is a type parameter then just use its textual value
    if (declaration.kind === typescript_1.SyntaxKind.TypeParameter) {
        return nodeToString_1.nodeToString(declaration);
    }
    // if the declaration is being initialized then use the initialization value
    var initializer = getInitializer(declaration);
    return initializer ? nodeToString_1.nodeToString(initializer) : '';
}
exports.getDeclarationTypeText = getDeclarationTypeText;
function getType(declaration) {
    return declaration.type;
}
function getInitializer(declaration) {
    return declaration.initializer;
}
exports.getInitializer = getInitializer;
//# sourceMappingURL=getDeclarationTypeText.js.map