"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var getExportDocType_1 = require("./getExportDocType");
var path = require('canonical-path');
describe('getExportDocType', function () {
    var parser;
    var basePath;
    beforeEach(function () {
        parser = new _1.TsParser(require('dgeni/lib/mocks/log')(false));
        basePath = path.resolve(__dirname, '../../mocks');
    });
    it('should return the accessibility of class members', function () {
        var parseInfo = parser.parse(['tsParser/getExportDocType.test.ts'], basePath);
        var moduleExports = parseInfo.moduleSymbols[0].exportArray;
        expect(getExportDocType_1.getExportDocType(moduleExports[0])).toEqual('interface');
        expect(getExportDocType_1.getExportDocType(moduleExports[1])).toEqual('class');
        expect(getExportDocType_1.getExportDocType(moduleExports[2])).toEqual('function');
        expect(getExportDocType_1.getExportDocType(moduleExports[3])).toEqual('enum');
        expect(getExportDocType_1.getExportDocType(moduleExports[4])).toEqual('let');
        expect(getExportDocType_1.getExportDocType(moduleExports[5])).toEqual('const');
        expect(getExportDocType_1.getExportDocType(moduleExports[6])).toEqual('type-alias');
    });
});
//# sourceMappingURL=getExportDocType.spec.js.map