"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var nodeToString_1 = require("./nodeToString");
var path = require('canonical-path');
describe('nodeToString', function () {
    var parser;
    var basePath;
    beforeEach(function () {
        parser = new _1.TsParser(require('dgeni/lib/mocks/log')(false));
        basePath = path.resolve(__dirname, '../../mocks');
    });
    it('should return text representation of a node, with the comments stripped out', function () {
        var parseInfo = parser.parse(['tsParser/nodeToString.test.ts'], basePath);
        var moduleExports = parseInfo.moduleSymbols[0].exportArray;
        expect(nodeToString_1.nodeToString(moduleExports[0].declarations[0])).toEqual([
            'export class TestClass {',
            '    someProp: number;',
            '    constructor() {',
            '    }',
            '    foo(param1: string) { }',
            '}',
        ].join('\n'));
    });
});
//# sourceMappingURL=nodeToString.spec.js.map