"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ConstExportDoc_1 = require("../api-doc-types/ConstExportDoc");
function convertPrivateClassesToInterfaces(exportDocs, addInjectableReference) {
    exportDocs.forEach(function (exportDoc) {
        // Search for classes with a constructor marked as `@internal`
        if (exportDoc.docType === 'class' && exportDoc.constructorDoc && exportDoc.constructorDoc.internal) {
            // Convert this class to an interface with no constructor
            exportDoc.docType = 'interface';
            exportDoc.constructorDoc = null;
            // convert the heritage since interfaces use `extends` not `implements`
            exportDoc.extendsClauses = exportDoc.extendsClauses.concat(exportDoc.implementsClauses);
            if (addInjectableReference) {
                // Add the `declare var SomeClass extends InjectableReference` construct
                var constExportDoc = new ConstExportDoc_1.ConstExportDoc(exportDoc.moduleDoc, exportDoc.symbol);
                constExportDoc.type = 'InjectableReference';
                exportDocs.push(constExportDoc);
            }
        }
    });
}
exports.convertPrivateClassesToInterfaces = convertPrivateClassesToInterfaces;
//# sourceMappingURL=convertPrivateClassesToInterfaces.js.map